-- $Id: gondolin-golden-flower.lua 3279 2018-03-09 04:36:28Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2018 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

store_util.set_prices(npc.owner, player, {
  ench_arrows = {1100, 1000, 200},
  ench_bow = {1100, 1000, 200},
})

newChat {
  id = 'welcome',
  text = [[#LIGHT_GREEN#*A tall, noble-looking High-Elf with long blond hair is here, fletching arrows.  He looks up as you enter.*#LAST#
Ah, they must have sent you to me.  You have the posture of an archer, unless my eyes deceive me, and you'll find no better bowyer in Gondolin.]],
  answers = {
    {
      'Can you improve my bow?' .. store_util.cost_sfx('ench_bow'),
      cond = function(npc, player)
	return store_util.has_gear(player, function(inv, o)
	  return inv.worn and o.type == 'shooter' and o.subtype == 'bow'
	end)
      end,
      action = function(npc, player, dlg)
	local function cb(inv, o)
	  return inv.worn and o.type == 'shooter' and o.subtype == 'bow'
	end
	return store_util.enchant_item(player, dlg, cb, {'bow', 'bows'}, prices.ench_bow, 'enchant', npc.owner.name)
      end,
    },
    {
      'Can you improve my arrows?' .. store_util.cost_sfx('ench_arrows'),
      cond = function(npc, player)
	return store_util.has_gear(player, function(inv, o)
	  return not inv.worn and o.type == 'ammo' and o.subtype == 'arrows'
	end)
      end,
      action = function(npc, player, dlg)
	local function cb(inv, o)
	  return not inv.worn and o.type == 'shooter' and o.subtype == 'bow'
	end
	return store_util.enchant_item(player, dlg, cb, {'bow', 'bows'}, prices.ench_bow, 'enchant', npc.owner.name)
      end,
    },
    { "...I look like an archer to you?  Have you considered corrective eyewear? [leave]" },
  },
}

newChat {
  id = 'enchant',
  text = [[Well, that didn't work.  This store must be broken.]],
  answers = {
    { 'Ohh...kay, then. [leave]' }
  },
}

return 'welcome'
