-- $Id: gondolin-star-dome.lua 3278 2018-03-09 04:13:23Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2018 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

store_util.set_prices(npc.owner, player, {
  id_pack = {1200, 1000, 250},
  recharge = {1200, 1000, 150},
})

newChat {
  id = 'welcome',
  text = store_util.price_interp([[#LIGHT_GREEN#*You enter a high dome.  The ceiling is painted like a starry night sky, with many constellations you recognize and a few you don't.  A Palantír is prominently displayed on a high pedestal in the center of the dome.  A bored-looking High-Elf is sitting behind a desk nearby.*#LAST#
Welcome to the Dome of Stars, Palantír of Osgiliath, blah blah blah.  ID's @price.id_pack@ gold, recharge is @price.recharge@ gold.]]),
  answers = {
    {
      'Can you identify my possessions, please?' .. store_util.cost_sfx('id_pack'),
      action = store_util.id_pack,
      cond = store_util.can_afford('id_pack'),
    },
    {
      'Can you recharge this wand/staff/rod, please?' .. store_util.cost_sfx('recharge'),
      action = store_util.recharge_item,
      cond = store_util.can_afford('recharge'),
    },
    { 'Oh, sorry, I was looking for the potion store. [leave]' },
  },
}

return 'welcome'
