-- $Id: gondolin-valarin-temple.lua 3278 2018-03-09 04:13:23Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2018 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

store_util.set_prices(npc.owner, player, {
  heal = {600, 400, 0},
  restore = {1200, 1000, 200},
})

newChat {
  id = 'welcome',
  text = [[Enter the temple of the Valar, child, and be welcome.  For our adventuring visitors, we offer healing prayers to restore your life and cure many ailments, or a restorative prayer to heal debilitations of the body and mind.  All for a small donation to the temple, of course.]],
  answers = {
    {
      'A healing prayer, please. #YELLOW#(heal 200hp, cure poison/blind/confusion/cut/stun)#LAST#' .. store_util.cost_sfx('heal'),
      cond = store_util.can_afford('heal'),
      action = store_util.healing,
    },
    {
      'A restorative prayer, please. #YELLOW#(restore all stats)#LAST#' .. store_util.cost_sfx('restore'),
      cond = store_util.can_afford('restore'),
      action = store_util.restoration,
    },
    { "Sorry, don't let me interrupt your prayers. [leave]" }
  },
}

return 'welcome'
