-- $Id: quest-lost-sword.lua 2835 2017-04-11 00:13:59Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

local lev = game.zone:level_adjust_level(game.level, 'actor')
local state = game.state.sword_quests[lev]

local function start(npc, player, dlg)
  -- We count on ActorQuest:grantQuest() to make this a no-op if we already
  -- have the quest.
  player:grantQuest('lost-sword')
end

local function extra_answer()
  local n = 0
  for _, state in pairs(game.state.sword_quests) do
    if state.done then n = n + 1 end
  end
  if n == 0 then return nil end

  local early = {
    [[...Wait, have I seen you before?]],
    [[No, seriously, you're the same guy who lost his sword before, right?]],
    [[Dude, hiding under the cloak doesn't help.  I know it's you.]],
  }
  local late = {
    [[Have you considered taking up archery?]],
    [[Dude, seriously, strap the sword to your arm with a leash or something.]],
    [[You really ought to invest in a backup dagger, y'know.]],
    [[Y'know, mages don't tend to get their swords stolen.  Just sayin'.]],
  }
  local text = n <= #early and early[n] or rng.table(late)
  return { text, action=start }
end

newChat {
  id = 'begin',
  text = [[#LIGHT_GREEN#*A dark-cloaked figure steps out of the shadows.*#LAST#
Forgive my impertinence, brave adventurer, but I am in dire straits.  A pack of ]]..state.pl_name..[[ have stolen my sword, and without it I fear I am helpless.  Could I prevail upon you to slay them and retrieve my sword for me?]],
  answers = {
    { [[That's terrible.  Sure, I'll help.]], action=start },
    extra_answer(),
  }
}

return 'begin'
