-- $Id: dragon-armor.lua 3333 2018-04-20 00:32:38Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2018 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_obj' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Object entities generated from T2's k_info.txt

newEntity {
  base = 'DRAGON_ARMOR_BASE',
  define_as = 'BLACK_DRAGON_SCALE_MAIL',
  name = 'BLACK_DRAGON_SCALE_MAIL',
  display_name = '& Black Dragon Scale Mail~',
  desc = [[An armour made of a black dragon's hide, containing some of this beast's powers.]],
  sval = 1,
  color = colors.C_s,
  image = 'object/black_dragon_scale_mail.png',
  level = 60,
  weight = 20,
  encumber = 20,
  cost = 50000,
  armor = 30,
  to_a = 10,
  convey_resist_dam = { [DamageType.ACID]=true },
  convey_flags = { FLY=true },
  ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
  obvious_flags = { convey_resist_dam = { [DamageType.ACID]=true } },
  allocation = { { level=60, rarity=8 } },
  -- BEGIN VERBATIM
  use_power = {
    use = function(self, who, inven, floor, item)
      local DamageType = require 'engine.DamageType'
      game.logPlayer(who, 'You breathe acid.')
      local ret = spell.ball_spell(who, nil, DamageType.ACID, 130, 2, nil, nil, 20)
      return { used=ret }
    end,
    power = { 90, 90 },
    name = 'breathe acid (dam 130, rad 2)',
  },
  cant_use_if = { not_wielded=true },
  power = 0,
  power_regen = -1,
  -- END VERBATIM
}

newEntity {
  base = 'DRAGON_ARMOR_BASE',
  define_as = 'BLUE_DRAGON_SCALE_MAIL',
  name = 'BLUE_DRAGON_SCALE_MAIL',
  display_name = '& Blue Dragon Scale Mail~',
  desc = 'A piece of dragon hide fashioned into an armour, shimmering bright blue.',
  sval = 2,
  color = colors.C_b,
  image = 'object/blue_dragon_scale_mail.png',
  level = 50,
  weight = 20,
  encumber = 20,
  cost = 40000,
  armor = 30,
  to_a = 10,
  convey_resist_dam = { [DamageType.ELEC]=true },
  convey_flags = { FLY=true },
  ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
  obvious_flags = { convey_resist_dam = { [DamageType.ELEC]=true } },
  allocation = { { level=50, rarity=8 } },
  -- BEGIN VERBATIM
  use_power = {
    use = function(self, who, inven, floor, item)
      local DamageType = require 'engine.DamageType'
      game.logPlayer(who, 'You breathe lightning.')
      local ret = spell.ball_spell(who, nil, DamageType.ELEC, 100, 2, nil, nil, 20)
      return { used=ret }
    end,
    power = { 90, 90 },
    name = 'breathe lightning (dam 100, rad 2)',
  },
  cant_use_if = { not_wielded=true },
  power = 0,
  power_regen = -1,
  -- END VERBATIM
}

newEntity {
  base = 'DRAGON_ARMOR_BASE',
  define_as = 'WHITE_DRAGON_SCALE_MAIL',
  name = 'WHITE_DRAGON_SCALE_MAIL',
  display_name = '& White Dragon Scale Mail~',
  desc = 'An armour fashioned from dragon hide, glistening the white of snow.',
  sval = 3,
  color = colors.C_w,
  image = 'object/white_dragon_scale_mail.png',
  level = 50,
  weight = 20,
  encumber = 20,
  cost = 40000,
  armor = 30,
  to_a = 10,
  convey_resist_dam = { [DamageType.COLD]=true },
  convey_flags = { FLY=true },
  ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
  obvious_flags = { convey_resist_dam = { [DamageType.COLD]=true } },
  allocation = { { level=50, rarity=8 } },
  -- BEGIN VERBATIM
  use_power = {
    use = function(self, who, inven, floor, item)
      local DamageType = require 'engine.DamageType'
      game.logPlayer(who, 'You breathe frost.')
      local ret = spell.ball_spell(who, nil, DamageType.COLD, 110, 2, nil, nil, 20)
      return { used=ret }
    end,
    power = { 90, 90 },
    name = 'breathe frost (dam 110, rad 2)',
  },
  cant_use_if = { not_wielded=true },
  power = 0,
  power_regen = -1,
  -- END VERBATIM
}

newEntity {
  base = 'DRAGON_ARMOR_BASE',
  define_as = 'RED_DRAGON_SCALE_MAIL',
  name = 'RED_DRAGON_SCALE_MAIL',
  display_name = '& Red Dragon Scale Mail~',
  desc = 'The skin of a dragon made into a suit of armour. It glows a bright red and radiates heat.',
  sval = 4,
  color = colors.C_r,
  image = 'object/red_dragon_scale_mail.png',
  level = 60,
  weight = 20,
  encumber = 20,
  cost = 50000,
  armor = 30,
  to_a = 10,
  convey_resist_dam = { [DamageType.FIRE]=true },
  convey_flags = { FLY=true },
  ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
  obvious_flags = { convey_resist_dam = { [DamageType.FIRE]=true } },
  allocation = { { level=60, rarity=8 } },
  -- BEGIN VERBATIM
  use_power = {
    use = function(self, who, inven, floor, item)
      local DamageType = require 'engine.DamageType'
      game.logPlayer(who, 'You breathe fire.')
      local ret = spell.ball_spell(who, nil, DamageType.FIRE, 200, 2, nil, nil, 20)
      return { used=ret }
    end,
    power = { 90, 90 },
    name = 'breathe fire (dam 200, rad 2)',
  },
  cant_use_if = { not_wielded=true },
  power = 0,
  power_regen = -1,
  -- END VERBATIM
}

newEntity {
  base = 'DRAGON_ARMOR_BASE',
  define_as = 'GREEN_DRAGON_SCALE_MAIL',
  name = 'GREEN_DRAGON_SCALE_MAIL',
  display_name = '& Green Dragon Scale Mail~',
  desc = 'A suit of armour fashioned of dragon hide. It is dirty green and smells awful.',
  sval = 5,
  color = colors.C_g,
  image = 'object/green_dragon_scale_mail.png',
  level = 50,
  weight = 20,
  encumber = 20,
  cost = 40000,
  armor = 30,
  to_a = 10,
  convey_resist_dam = { [DamageType.POISON]=true },
  convey_flags = { FLY=true },
  ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
  obvious_flags = { convey_resist_dam = { [DamageType.POISON]=true } },
  allocation = { { level=50, rarity=8 } },
  -- BEGIN VERBATIM
  use_power = {
    use = function(self, who, inven, floor, item)
      local DamageType = require 'engine.DamageType'
      game.logPlayer(who, 'You breathe poison gas.')
      local ret = spell.ball_spell(who, nil, DamageType.POISON, 150, 2, nil, nil, 20)
      return { used=ret }
    end,
    power = { 90, 90 },
    name = 'breathe poison gas (dam 150, rad 2)',
  },
  cant_use_if = { not_wielded=true },
  power = 0,
  power_regen = -1,
  -- END VERBATIM
}

newEntity {
  base = 'DRAGON_ARMOR_BASE',
  define_as = 'MULTI_HUED_DRAGON_SCALE_MAIL',
  name = 'MULTI_HUED_DRAGON_SCALE_MAIL',
  display_name = '& Multi-Hued Dragon Scale Mail~',
  desc = 'A powerful armour made of dragonhide. It glows red, blue, green, black and white.',
  sval = 6,
  color = colors.C_v,
  image = 'object/multi_hued_dragon_scale_mail.png',
  level = 90,
  weight = 20,
  encumber = 20,
  cost = 150000,
  armor = 30,
  to_a = 10,
  convey_resist_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true, [DamageType.POISON]=true },
  convey_flags = { FLY=true },
  flags = { ATTR_MULTI=true },
  ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
  obvious_flags = { convey_resist_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true, [DamageType.POISON]=true } },
  allocation = { { level=90, rarity=32 } },
  -- BEGIN VERBATIM
  use_power = {
    use = function(self, who, inven, floor, item)
      local DamageType = require 'engine.DamageType'
      local br_types = {
	{ name='lightning', dt=DamageType.ELEC },
	{ name='frost', dt=DamageType.COLD },
	{ name='acid', dt=DamageType.ACID },
	{ name='poison gas', dt=DamageType.POISON },
	{ name='fire', dt=DamageType.FIRE },
      }
      local br_type = rng.table(br_types)
      game.logPlayer(who, 'You breathe %s.', br_type.name)
      local ret = spell.ball_spell(who, nil, br_type.dt, 250, 2, nil, nil, 20)
      return { used=ret }
    end,
    power = { 60, 60 },
    name = 'breathe one of lightning, frost, acid, fire or poison gas (dam 250, rad 2)',
  },
  cant_use_if = { not_wielded=true },
  power = 0,
  power_regen = -1,
  -- END VERBATIM
}

newEntity {
  base = 'DRAGON_ARMOR_BASE',
  define_as = 'PSEUDO_DRAGON_SCALE_MAIL',
  name = 'PSEUDO_DRAGON_SCALE_MAIL',
  display_name = '& Pseudo Dragon Scale Mail~',
  desc = 'A suit of armour made of dragon hide, glowing with a strange light, or is it darkness?',
  sval = 10,
  color = colors.C_v,
  image = 'object/pseudo_dragon_scale_mail.png',
  level = 70,
  weight = 20,
  encumber = 20,
  cost = 70000,
  armor = 30,
  to_a = 10,
  convey_resist_dam = { [DamageType.LITE]=true, [DamageType.DARK]=true },
  convey_flags = { FLY=true },
  ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
  allocation = { { level=70, rarity=16 } },
  -- BEGIN VERBATIM
  use_power = {
    use = function(self, who, inven, floor, item)
      local DamageType = require 'engine.DamageType'
      local br_types = {
	{ name='light', dt=DamageType.LITE },
	{ name='darkness', dt=DamageType.DARK },
      }
      local br_type = rng.table(br_types)
      game.logPlayer(who, 'You breathe %s.', br_type.name)
      local ret = spell.ball_spell(who, nil, br_type.dt, 200, 2, nil, nil, 20)
      return { used=ret }
    end,
    power = { 60, 90 },
    name = 'breathe light or darkness (dam 200, rad 2)',
  },
  cant_use_if = { not_wielded=true },
  power = 0,
  power_regen = -1,
  -- END VERBATIM
}

newEntity {
  base = 'DRAGON_ARMOR_BASE',
  define_as = 'LAW_DRAGON_SCALE_MAIL',
  name = 'LAW_DRAGON_SCALE_MAIL',
  display_name = '& Law Dragon Scale Mail~',
  desc = [[A piece of dragonhide cut and shaped so it can be worn as armour. The scales are very sharp, and the roaring of a storm seems to come from it, but you're not afraid of either.]],
  sval = 12,
  color = colors.C_B,
  image = 'object/law_dragon_scale_mail.png',
  level = 80,
  weight = 20,
  encumber = 20,
  cost = 80000,
  armor = 30,
  to_a = 10,
  convey_resist_dam = { [DamageType.SOUND]=true, [DamageType.SHARDS]=true },
  convey_flags = { FLY=true },
  ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
  allocation = { { level=80, rarity=16 } },
  -- BEGIN VERBATIM
  use_power = {
    use = function(self, who, inven, floor, item)
      local DamageType = require 'engine.DamageType'
      local br_types = {
	{ name='sound', dt=DamageType.SOUND },
	{ name='shards', dt=DamageType.SHARDS },
      }
      local br_type = rng.table(br_types)
      game.logPlayer(who, 'You breathe %s.', br_type.name)
      local ret = spell.ball_spell(who, nil, br_type.dt, 230, 2, nil, nil, 20)
      return { used=ret }
    end,
    power = { 60, 90 },
    name = 'breathe sound or shards (dam 230, rad 2)',
  },
  cant_use_if = { not_wielded=true },
  power = 0,
  power_regen = -1,
  -- END VERBATIM
}

newEntity {
  base = 'DRAGON_ARMOR_BASE',
  define_as = 'BRONZE_DRAGON_SCALE_MAIL',
  name = 'BRONZE_DRAGON_SCALE_MAIL',
  display_name = '& Bronze Dragon Scale Mail~',
  desc = 'A suit of armour made from dragon skin. Its brownish scales glitter in a dazzling light.',
  sval = 14,
  color = colors.C_U,
  image = 'object/bronze_dragon_scale_mail.png',
  level = 50,
  weight = 20,
  encumber = 20,
  cost = 40000,
  armor = 30,
  to_a = 10,
  convey_resist_dam = { [DamageType.CONFUSION]=true },
  convey_flags = { FLY=true },
  ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
  allocation = { { level=50, rarity=8 } },
  -- BEGIN VERBATIM
  use_power = {
    use = function(self, who, inven, floor, item)
      local DamageType = require 'engine.DamageType'
      game.logPlayer(who, 'You breathe confusion.')
      local ret = spell.ball_spell(who, nil, DamageType.POISON, 120, 2, nil, nil, 20)
      return { used=ret }
    end,
    power = { 90, 90 },
    name = 'breathe confusion (dam 120, rad 2)',
  },
  cant_use_if = { not_wielded=true },
  power = 0,
  power_regen = -1,
  -- END VERBATIM
}

newEntity {
  base = 'DRAGON_ARMOR_BASE',
  define_as = 'GOLD_DRAGON_SCALE_MAIL',
  name = 'GOLD_DRAGON_SCALE_MAIL',
  display_name = '& Gold Dragon Scale Mail~',
  desc = 'A suit of golden-hued armour made of dragonhide. The rustle of its scales occasionally increases to a loud boom.',
  sval = 16,
  color = colors.C_y,
  image = 'object/gold_dragon_scale_mail.png',
  level = 60,
  weight = 20,
  encumber = 20,
  cost = 50000,
  armor = 30,
  to_a = 10,
  convey_resist_dam = { [DamageType.SOUND]=true },
  convey_flags = { FLY=true },
  ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
  allocation = { { level=60, rarity=8 } },
  -- BEGIN VERBATIM
  use_power = {
    use = function(self, who, inven, floor, item)
      local DamageType = require 'engine.DamageType'
      game.logPlayer(who, 'You breathe sound.')
      local ret = spell.ball_spell(who, nil, DamageType.POISON, 130, 2, nil, nil, 20)
      return { used=ret }
    end,
    power = { 90, 90 },
    name = 'breathe sound (dam 130, rad 2)',
  },
  cant_use_if = { not_wielded=true },
  power = 0,
  power_regen = -1,
  -- END VERBATIM
}

newEntity {
  base = 'DRAGON_ARMOR_BASE',
  define_as = 'CHAOS_DRAGON_SCALE_MAIL',
  name = 'CHAOS_DRAGON_SCALE_MAIL',
  display_name = '& Chaos Dragon Scale Mail~',
  desc = 'A suit of armour made of dragon hide. It glows in colours you have never seen before. As you put it on, you feel like you could change the world and are no longer afraid of your equipment losing its magic.',
  sval = 18,
  color = colors.C_v,
  image = 'object/chaos_dragon_scale_mail.png',
  level = 80,
  weight = 20,
  encumber = 20,
  cost = 80000,
  armor = 30,
  to_a = 10,
  convey_resist_dam = { [DamageType.CHAOS]=true, [DamageType.DISENCHANT]=true },
  convey_flags = { FLY=true },
  flags = { ATTR_MULTI=true },
  ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
  obvious_flags = { convey_resist_dam = { [DamageType.CHAOS]=true } },
  allocation = { { level=80, rarity=16 } },
  -- BEGIN VERBATIM
  use_power = {
    use = function(self, who, inven, floor, item)
      local DamageType = require 'engine.DamageType'
      local br_types = {
	{ name='chaos', dt=DamageType.CHAOS },
	{ name='disenchantment', dt=DamageType.DISENCHANT },
      }
      local br_type = rng.table(br_types)
      game.logPlayer(who, 'You breathe %s.', br_type.name)
      local ret = spell.ball_spell(who, nil, br_type.dt, 220, 2, nil, nil, 20)
      return { used=ret }
    end,
    power = { 60, 60 },
    name = 'breathe chaos or disenchantment (dam 220, rad 2)',
  },
  cant_use_if = { not_wielded=true },
  power = 0,
  power_regen = -1,
  -- END VERBATIM
}

newEntity {
  base = 'DRAGON_ARMOR_BASE',
  define_as = 'BALANCE_DRAGON_SCALE_MAIL',
  name = 'BALANCE_DRAGON_SCALE_MAIL',
  display_name = '& Balance Dragon Scale Mail~',
  desc = 'A suit of armour made of the hide of a dead dragon. When wearing it, you feel like you understand the principles of law and chaos, and no longer fear either.',
  sval = 20,
  color = colors.C_v,
  image = 'object/balance_dragon_scale_mail.png',
  level = 95,
  weight = 20,
  encumber = 20,
  cost = 100000,
  armor = 30,
  to_a = 10,
  convey_resist_dam = { [DamageType.CHAOS]=true, [DamageType.DISENCHANT]=true, [DamageType.SOUND]=true, [DamageType.SHARDS]=true },
  convey_flags = { FLY=true },
  ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
  allocation = { { level=95, rarity=32 } },
  -- BEGIN VERBATIM
  use_power = {
    use = function(self, who, inven, floor, item)
      local DamageType = require 'engine.DamageType'
      local br_types = {
	{ name='chaos', dt=DamageType.CHAOS },
	{ name='disenchantment', dt=DamageType.DISENCHANT },
	{ name='sound', dt=DamageType.SOUND },
	{ name='shards', dt=DamageType.SHARDS },
      }
      local br_type = rng.table(br_types)
      game.logPlayer(who, 'You breathe %s.', br_type.name)
      local ret = spell.ball_spell(who, nil, br_type.dt, 250, 2, nil, nil, 20)
      return { used=ret }
    end,
    power = { 60, 90 },
    name = 'breathe one of chaos, disenchantment, sound or shards (dam 250, rad 2)',
  },
  cant_use_if = { not_wielded=true },
  power = 0,
  power_regen = -1,
  -- END VERBATIM
}

newEntity {
  base = 'DRAGON_ARMOR_BASE',
  define_as = 'POWER_DRAGON_SCALE_MAIL',
  name = 'POWER_DRAGON_SCALE_MAIL',
  display_name = '& Power Dragon Scale Mail~',
  desc = [[A suit of armour made of a very thick richly coloured dragonhide. You think you'll never have to fear dragons if you put it on.]],
  sval = 30,
  color = colors.C_v,
  image = 'object/power_dragon_scale_mail.png',
  level = 100,
  weight = 25,
  encumber = 25,
  cost = 350000,
  armor = 40,
  to_a = 15,
  convey_resist_dam = { [DamageType.ACID]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true, [DamageType.ELEC]=true, [DamageType.POISON]=true, [DamageType.NETHER]=true, [DamageType.NEXUS]=true, [DamageType.CHAOS]=true, [DamageType.LITE]=true, [DamageType.DARK]=true, [DamageType.SHARDS]=true, [DamageType.SOUND]=true, [DamageType.DISENCHANT]=true, [DamageType.CONFUSION]=true },
  convey_flags = { FLY=true },
  flags = { ATTR_MULTI=true },
  ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
  allocation = { { level=100, rarity=64 } },
  -- BEGIN VERBATIM
  use_power = {
    use = function(self, who, inven, floor, item)
      local DamageType = require 'engine.DamageType'
      game.logPlayer(who, 'You breathe the elements.')
      local ret = spell.ball_spell(who, nil, DamageType.MISSILE, 300, 3, nil, nil, 20)
      return { used=ret }
    end,
    power = { 60, 90 },
    name = 'breathe the elements (dam 300, rad 3)',
  },
  cant_use_if = { not_wielded=true },
  power = 0,
  power_regen = -1,
  -- END VERBATIM
}
-- 13 total items
-- color:  colors.C_B=1; colors.C_U=1; colors.C_b=1; colors.C_g=1; colors.C_r=1; colors.C_s=1; colors.C_v=5; colors.C_w=1; colors.C_y=1
-- level:  100=1; 50=4; 60=3; 70=1; 80=2; 90=1; 95=1
-- weight:  200=12; 250=1
-- cost:  100000=1; 150000=1; 350000=1; 40000=4; 50000=3; 70000=1; 80000=2
-- armor:  30=12; 40=1
-- to_a:  10=12; 15=1
