-- $Id: bree-thieves.lua 4105 2020-10-06 00:49:10Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2020 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

local function mark_mon(tag)
  return {
    name = tag,
    entity_mod = function(m)
      m.quest_mon = true
      m.quest_on_die = 'bree-house'
      return m
    end
  }
end

local function mark_obj(tag)
  return {
    name = tag,
    resolve_flags = {
      force_good = true,
    }
  }
end

addData { quest_level = 'bree-house' }

defineTile('x', 'PERMA_WALL', nil, nil, nil, { lite=true })
defineTile('X', 'PERMA_WALL')
defineTile('.', 'FLOOR', nil, nil, nil, { lite=true })
defineTile(',', 'FLOOR')
defineTile('d', 'OPEN_DOOR', nil, nil, nil, { lite=true })
defineTile('D', 'LOCKED_DOOR', nil, nil, nil, { lite=true, lock_power=6 })
-- The game describes this as "magically locked"; no idea what that means
defineTile('M', 'LOCKED_DOOR', nil, nil, nil, { lite=true, lock_power=6 })
defineTile('A', 'ALARM_DOOR', nil, nil, nil, { lock_power=6 })
defineTile('a', 'FLOOR', nil, mark_mon('NOVICE_ROGUE'), nil, { lite=true })
defineTile('b', 'FLOOR', mark_obj('DAGGER'), mark_mon('BANDIT'), nil, { lite=true })
defineTile('c', 'FLOOR', nil, mark_mon('NOVICE_WARRIOR'), nil, { lite=true })
defineTile('e', 'FLOOR', nil, mark_mon('NOVICE_MAGE'), nil, { lite=true })
defineTile('f', 'FLOOR', nil, mark_mon('NOVICE_WARRIOR'))
defineTile('z', 'FLOOR', 'HUMAN_SKELETON', nil, nil, { lite=true })

-- Remember the exit spot for future reference.
defineTile('<', 'FLOOR', nil, nil, nil, nil, { type='quest', subtype='exit' })
defineTile('+', 'FLOOR', nil, nil, nil, { lite=true }, { type='quest', subtype='player-inven' })
defineTile('R', 'LOCKED_DOOR', nil, nil, nil, { lite=true, lock_power=6 }, { type='quest', subtype='rigged-door' })

startx = 2
starty = 2
return [[
xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
x.....x....zx.....x.............x
x.....x.....x.....x.............x
x.....x.....x.....x....+........x
xxxMxxxxxdxxxxxdxxxxxxxxxDxxxxxxx
XXx..........................xXXX
XXx.xxxxx.xxxxx.xxxxxxxxx.xx,xXXX
XXxxxXXXxxxXXXxxxXXXXXXXxxx,,,XXX
XXXXxxxxxxxxxxxxxxxxxXXXXX,,,,,XX
XXXXxe..xb..x...x...xXXXX,,,,,,,X
XXXXx...x...xa..x...xXXXX,,,,,,,X
XXXXx...x...x...x.a.xXXXX,,,,,,,X
xxxxxxRxxxRxxxRxxxRxxXXXXX,,,,,XX
x,,,x...............xXXXXXX,,,XXX
x,,,x..x.........x..xXXXXXXX,XXXX
x,,,D.....x...x.....A,,,,,,,,XXXX
x,,,x..x.........x..xXXXXXXXXXXXX
x,,,x...............xXXXXXXXXXXXX
x,,,xxRxxxRxxxRxxxRxxXXXXXXXXXXXX
x,,,x...x...x.a.xa..xXXXXXXXXXXXX
x,,,xc..x.a.x...x...xXXXXXXXXXXXX
xf<fx...x...x...x...xXXXXXXXXXXXX
xxxxxxxxxxxxxxxxxxxxxXXXXXXXXXXXX]]
