-- $Id: thrain.lua 4105 2020-10-06 00:49:10Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2020 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'convert-map' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Thrain quest map generated from thrain.map with the following args:
--   --mimic 'mimic_hack'
--   -M ,='thrain-quest:thrain'
--   -M .='thrain-quest:hidden'
--   -M 1='thrain-quest:hidden'
--   -M 2='thrain-quest:hidden'
--   -M D='thrain-quest:hidden'
--   -M l='thrain-quest:hidden'
--   -M o='thrain-quest:hidden'

-- BEGIN VERBATIM

-- TILE_HACK , 2 'THRAIN_THE_KING_UNDER_THE_MOUNTAIN'

local function mark_mon(tag)	-- MARK DWAR_DOG_LORD_OF_WAW,HOARMURATH_OF_DIR
  return {
    name = tag,
    entity_mod = function(m)
      m.quest_mon = true
      m.quest_on_die = 'thrain'
      return m
    end,
  }
end

local function unhide_on_enter(g, x, y, who, forced)
  -- Don't forget to call the "parent" on_move().
  require('mod.class.Grid').on_move(g, x, y, who, forced)
  if who.player then
    local q = who:hasQuest('thrain')
    q:unhide_room()
  end
end

local function mimic_hack(base, display)
  local g = zone.grid_list[base]:clone()
  g.replace_display = zone.grid_list[display]
  g.block_sight = true
  g.on_move = unhide_on_enter
  return g
end

addData { quest_level = 'thrain' }

-- END VERBATIM

defineTile('.', mimic_hack('FLOOR', 'PERMA_WALL'), nil, nil, nil, nil, { type='thrain-quest', subtype='hidden' })
defineTile('1', mimic_hack('FLOOR', 'PERMA_WALL'), nil, mark_mon('DWAR_DOG_LORD_OF_WAW'), nil, { quest_mon=true }, { type='thrain-quest', subtype='hidden' })
defineTile('2', mimic_hack('FLOOR', 'PERMA_WALL'), nil, mark_mon('HOARMURATH_OF_DIR'), nil, { quest_mon=true }, { type='thrain-quest', subtype='hidden' })
defineTile('o', mimic_hack('FLOOR', 'PERMA_WALL'), nil, 'ELITE_URUK', nil, nil, { type='thrain-quest', subtype='hidden' })
defineTile(',', mimic_hack('FLOOR', 'PERMA_WALL'), nil, 'THRAIN_THE_KING_UNDER_THE_MOUNTAIN', nil, { lite=true, no_teleport=true }, { type='thrain-quest', subtype='thrain' })
defineTile('x', 'PERMA_WALL', nil, nil, nil, { lite=true, no_teleport=true })
defineTile('D', mimic_hack('SECRET_DOOR', 'PERMA_WALL'), nil, nil, nil, nil, { type='thrain-quest', subtype='hidden' })
defineTile('l', mimic_hack('DEEP_LAVA', 'PERMA_WALL'), nil, nil, nil, nil, { type='thrain-quest', subtype='hidden' })

return [[
          
 xxxxxxxx 
 xoooo..x 
 xo2oo..x 
 xlloo..x 
 x,loo..D 
 xlloo..x 
 xo1oo..x 
 xoooo..x 
 xxxxxxxx 
          ]]
