-- $Id: gondolin.lua 3850 2020-04-05 20:13:34Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2020 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

defineTile('^', 'MOUNTAIN_CHAIN')
defineTile('.', 'FLOOR')
defineTile('T', 'TREE')
defineTile('W', 'DEEP_WATER')
defineTile('V', 'SHALLOW_WATER')
defineTile('L', 'DEEP_LAVA')
defineTile('K', 'SHALLOW_LAVA')
defineTile('C', 'DARK_PIT')
defineTile(',', 'DIRT')
defineTile('-', 'GRASS')
defineTile('#', 'PERMA_WALL')
defineTile('"', 'SECTION_OF_THE_STRAIGHT_ROAD')
defineTile('$', 'SECTION_OF_THE_STRAIGHT_ROAD_5')

-- "Transparent" areas, passing through the previously generated tile from
-- PlasmaWilderness.
--defineTile(' ')

-- Remember some spots for future reference.
defineTile('z', 'MOUNTAIN_CHAIN', nil, nil, nil, nil, { type='quest', subtype='eol' })
defineTile('y', 'FLOOR', nil, nil, nil, nil, { type='quest', subtype='nirnaeth' })
defineTile('x', 'FLOOR', nil, nil, nil, nil, { type='quest', subtype='invasion' })
defineTile('w', 'PERMA_WALL', nil, nil, nil, nil, { type='quest', subtype='house' })
defineTile('Z', 'PERMA_WALL', nil, nil, nil, nil, { type='quest', subtype='between-gate' })
defineTile('!', 'PERMA_WALL', nil, nil, nil, nil, { type='quest', subtype='jewelry' })
defineTile(';', 'FLOOR', nil, nil, nil, nil, { type='quest', subtype='invasion-liron-entry' })

-- This is described as "Castle: Gondolin Plot" in t_gondol.txt.  No idea
-- what that's supposed to mean; just fill it in as perma-wall for now.
defineTile('B', 'PERMA_WALL')

defineTile('1', 'PERMA_WALL', nil, nil, 'GENERAL_STORE')
defineTile('2', 'PERMA_WALL', nil, nil, 'ARMOURY')
defineTile('3', 'PERMA_WALL', nil, nil, 'WEAPONSMITH')
defineTile('4', 'PERMA_WALL', nil, nil, 'TEMPLE')
defineTile('5', 'PERMA_WALL', nil, nil, 'ALCHEMY_SHOP')
defineTile('6', 'PERMA_WALL', nil, nil, 'MAGIC_SHOP')
defineTile('7', 'PERMA_WALL', nil, nil, 'BLACK_MARKET')
defineTile('a', 'PERMA_WALL', nil, nil, 'TOWER_OF_THE_KING')
defineTile('b', 'PERMA_WALL', nil, nil, 'GONDOLIN_LIBRARY')
defineTile('c', 'PERMA_WALL', nil, nil, 'THE_WHITE_TREE')
defineTile('d', 'PERMA_WALL', nil, nil, 'CRAFTSMASTER')
defineTile('e', 'PERMA_WALL', nil, nil, 'EARTH_DOME_NATURE_')
defineTile('f', 'PERMA_WALL', nil, nil, 'THE_SOOTHSAYER')
defineTile('h', 'PERMA_WALL', nil, nil, 'MINSTRELS_HAVEN')
defineTile('i', 'PERMA_WALL', nil, nil, 'STAR_DOME')
defineTile('j', 'PERMA_WALL', nil, nil, 'VALARIN_TEMPLE')
defineTile('k', 'PERMA_WALL', nil, nil, 'SEA_DOME')
defineTile('l', 'PERMA_WALL', nil, nil, 'THE_GOLDEN_FLOWER')
defineTile('m', 'PERMA_WALL', nil, nil, 'THE_FOUNTAIN')
defineTile('n', 'PERMA_WALL', nil, nil, 'THUNDERLORDS_NEST')
defineTile('o', 'PERMA_WALL', nil, nil, 'MERCHANTS_GUILD')

startx=42
starty=6

-- '@' tiles, also being undefined, will also pass through PlasmaWilderness
-- tiles; we use them for the border instead of ' ' purely for cosmetic
-- reasons, as spaces would be hard to see on the borders.
return [[
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@####################################################################################################################################################################################################@
@####################################################################################################################################################################################################@
@####################################################################################################################################################################################################@
@#####################################^^^^^^^^^^^^^,,,                                                                                                                                            ###@
@###################################^^^^^^^^^^^^,,,,                                                                                                                                              ###@
@#################################^^^^^^^^,,,,,,,,                                                                                                                                                ###@
@##########B#####################^^^^^^^^^,,,,,,                                                         CCCCCCCCCCCCCCCCCCCCCCCCC                                           ,,,,,,,           ,,,,##@
@###############################^^^^^^^^^^^,,,                                                    CCCCCCCC#######################CCCCCCCC                                 ,,,,,,,,,,,         ,,,,,##@
@##############################^^^^^^^^^^^^,,                                               CCCCCCC########TTTTTTTT#####TTTTTTTT########CCCCCC                           ,,,,,^^^^^,,,,        ,,,,##@
@#############################^^^^^^^^^^^,,,                                             CCCC########TTTTTT........###........TTTTTT########CCCC                        ,,,,^^^^^^^,,,,,,     ,,,,,##@
@############################^^^^^^^n^^,,,                                               CC###########T..........#########..........T###########CC                      ,,,,^^^^^^^^^^^^,,,,,,,,,,,##@
@###########################^^^^^^,,,,,,  ,      .........................              CC############T........#############........T############CC                     ,,,,^^^^^^^^^^^^^^,,,,,,,,,##@
@###########################,,,,,,,,,      -     .........................             CC#############T.......###WW#####WW###.......T#############CC                     ,,,,^^^^^^^^^^^^^,,,,,,,,,##@
@##########################,,,,,,          ,  ,- ...     .             ...             C#############TT.......#WWWW##h##WWWW#.......TT#############C                      ,,,,,^^^^^^^^^^^,,,,,,,,,##@
@##########################                 -,  -...     .        #### ... ####        C#############T..........VV###.###VV..........T#############C                        ,,,,,,^^^^^^^,,,  ,,,,,##@
@#########################                       ...   #####        ####5####         CC######WWWW###T...........V##...##V...........T####WWWW#####CC #########              ,,,,,,^^^^,,,     ,,,,##@
@#########################           #########   ...   #####         #######          C######TTTTWW#TT............#.....#............TT#WWTTTT######C #########                ,,,,,,,,,,      ,,,,##@
@###W###################W#           #########   ...   #####         #######          C#####l...TTW#T.................................T#WTT...T#####C #########                 ,,,,,,,,     ,,,,,,##@
@###WWWW#############WWWW#           #########   ...   #####         #######          C######T...............................................T######C     ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,    ,,,,,,,,##@
@####WWWWWWW#####WWWWWWW##           #########   ...   #####        #########         C######TTT.................TTTTTTTTT.................TTT######C     ,                    ,,,,,,,,,, ,,,,,,,,,##@
@####WWWWWWWWWWWWWWWWWWW##           ####w####   ...   #####      ######5######      CC#######WW..............TTTT#######TTTT..............WW#######CC    , ###                    ,,,,,,,,,,,,,,,,##@
@#####WWWWWWWWWWWWWWWWW###               .       ...                 ##...##         C##########............TTT#############TTT............##########C    , ##########                 ,,, ,,,,,,,,##@
@#####WWWWWWWWWWWWWWWWW###               ...........                   ...           C########TT...........TT#################TT...........TT########C    , ###################               ,,,,,##@
@#####WWWWWWWWWWWWWWWWW###                       ...                   ...           C#####TTTT...........TT###..###aaa###..###TT...........TTTT#####C    ,     ###############              ,,,,,,##@
@#######WWWWWWWWWWWWW######          #########   ...   #############   ...           C#TTTTT..............T##.....#!.;.Z#.....##T..............TTTTT#C    ,       ##############               ,,,,##@
@##########WWWWWWW##########         #########   ...   #############   ...           C#T...........###...TT##.....#.....#.....##TT...###...........T#C    ,       ##############                ,,,##@
@##############################      #########   ...   #############   ...           C#T.........####....T##......#.....#......##T....####.........T#C    ,        ###########                 ,,,,##@
@###--####KK#CC#VV#LL#""##           #########   ...   #############   ...          CC#TT.......####.....T##...................##T.....####.......TT#CC   ,        #### , ##                    ,,,##@
@###--####KK#CC#VV#LL#""##           #########   ...   ######1######   ...          C###T......####....TTT###.................###TTT....####......T###C   ,             ,    VVVVV             ,,,,##@
@###--####KK#CC#VV#LL#""#                        ...         .         ...          C###T......d###...TT###.###....#####....###.###TT...###b......T###C   ,,,,,,,,,,,,,,,   VVWWWVV             ,,,##@
@########################                        ...         .         ...          C###T......d###...T##.....##..##WWW##..##.....##T...###b......T###C   ,               VVVWWWWWV            ,,,,##@
@..............................................................................................####...T#.......#..#WV#VW#..#.......#T...####...........   ,            VVVVWWWWWWWV           ,,,,,##@
@.x.........y.....................................................................................................#W#V#W#..............................,,,,            VWWWWWWWWWWV            ,,,,##@
@..............................................................................................####...T#.......#..#WV#VW#..#.......#T...####...........   ,            VVWWWWWWWVVV           ,,,,,##@
@########################                .       ...         .           .          C###T......c###...T##.....##..##WWW##..##.....##T...####......T###C   ,             VWWWWWVVVV          ,,,,,^^##@
@###--####KK#CC#VV#LL#""#                .       ...         .           .          C###T......####...TT###.###....#####....###.###TT...####....TTT###C   ,             VVWWWVV            ,,,,,,^^##@
@###--####KK#CC#VV#LL#""##           ####1####   ...   ######2######   ##3##        C###T..............TTT###.................###TTT....####...TT#####C   ,              VVWWV           ,,,,,,^^^^##@
@###--####KK#CC#VV#LL#""###          #########   ...   #############   #####        CC#TT................T##...................##T.....####...TT#####CC   ,               VVVV         ,,,,,,^^^^^^##@
@##############################      ########1......   #############   #####         C#T.................T##......#.....#......##T....####....T######C    ,   ------TT------------     ,,,,,^^^^^^^##@
@##########$$$$$$$##########         #########   ...   #############   #####         C#T...VV...VV.......TT##.....##...##.....##TT...###.......f#####C    ,------TT-TTT--TT-TT-TT---- ,,,,^^^^^^^^^##@
@#######$$$$$$$$$$$$$######          #########   ...   #############   #####         C#T..VV#...#VV.......T####.#####m#####.####T..............f#####C   -,--TTTTTTTTTTTTTTT-TT-TTT---,,,,^^^^^^^^^##@
@#####$$$$$$$$$$$$$$$$$###                       ...                                 C#T..V###.###V.......TTT#################TTT.............T######C ---,--TT-TTT########TTT-TTTT----,,,,,^^^^^^^##@
@#####$$$$$$$$$$$$$$$$$###                       ...                                 C#TT.V##4.j##V.........TTT#############TTT...............TT#####C----,---TTT###TTTTTT###TT-T-TT----,,,,,^^^^^^##@
@#####$$$$$$$$$$$$$$$$$$##                       ...                                 C##T.V#######V...........TTTT#######TTTT..................TT####C----,--TTT##TTT----TTT##TTTTTT------,,,,,^^^^##@
@####$$$$$$$$$$$$$$$$$$$##           #########   ...   #############                 CC#T.VV#####VV.............................................TTT#CC----,---TT#TT--------TT##T-T-TT------,,,,^^^^##@
@####$$$$$$$#####$$$$$$$##           #########   ...   #############                  C#T..VV###VV.....TTTTTTTTTTT.......TTTTTTTTTTT..............T#C-----,,,,,,,,,,,,,,,,,,,e#TT-TTT------,,,,^^^^##@
@###$$$$#############$$$$#           ########o.........7############                  C#T...VVVVV....TTT#########TTT...TTT#########TTT............T#C----------T#TT--------TT##TTT-------,,,,^^^^^^##@
@###$###################$#           #########   ...   #############                  C#TT..........TT###VVVVVV####TT.TT####WWWWWW###TT..........TT#C--------TTT##TTT----TTT##TTTTT-----,,,,^^^^^^^##@
@#########################           #########   ...   #############                  C##T..........T##VVV....VVV###TTT###WWW....WWW##T..........T##C-------TTTTT###TTTTTT###TTTTT-----,,,,,^^^^^^^##@
@##########################                      ...                                  CC#T..........T#VV........VV#######WW........WW#T..........T#CC -----TTTT-TTT########TTTTTT------,,,,,,,^^^^^##@
@##########################                     #...#                                  C#TT.......................i#####k.......................TT#C   -T---TTTTT-TTTTTTTTTT-TT------   ,,,,,,,z^^^##@
@###########################                   ##...##                                 C##TT........T#VV........VV#######WW........WW#T........TT##C     ------TTTT-TT--TT---T-----   ,,,,,,,^^^^^^##@
@###########################                  ####6####                                CC##TT.......T##VVV....VVV#########WWW....WWW##T.......TT##CC        ------TTT-TTTT--T----- ,,,,,,,^^^^^^^^^##@
@############################                  #######                                  CC##TTTT...TTT###VVVVVV#############WWWWWW###TTT...TTTT##CC            ------T--------   ,,,,,,^^^^^^^^^^^^##@
@#############################                  #####                                    CC####TTTTTTTTT###########################TTTTTTTTT####CC                             ,,,,,,^^^^^^^^^^^^^^##@
@##############################                 #####                                     CCCC######TTTTTTTTTTT##############TTTTTTTTTT######CCCC                           ,,,,,,^^^^^^^^^^^^^^^^^##@
@###############################                #####                                        CCCCCC#####################################CCCCCC                          ,,,,,,,,,,^^^^^^^^^^^^^^^^^##@
@################################               #####                                             CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC                             ,,,,,,,,,,^^^^^^^^^^^^^^^^^^###@
@#################################             #######                                                                                                            ,,,,,,,,,,,^^^^^^^^^^^^^^^^^^^^^###@
@###################################          #########                                                                                                         ,,,,,,,,,,,,,^^^^^^^^^^^^^^^^^^^#####@
@#####################################      #############                                                                                                    ,,,,,,,,,,,,,,,^^^^^^^^^^^^^^^^^^#######@
@####################################################################################################################################################################################################@
@####################################################################################################################################################################################################@
@####################################################################################################################################################################################################@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@]]
