-- $Id: khazad-dum.lua 2835 2017-04-11 00:13:59Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

defineTile('^', 'MOUNTAIN_CHAIN')
defineTile('C', 'DARK_PIT')
defineTile(';', 'RUBBLE')
defineTile('#', 'PERMA_WALL')
defineTile('o', 'ROCKY_GROUND')

-- "Transparent" areas, passing through the previously generated tile from
-- PlasmaWilderness.
--defineTile(' ')

-- Remember some spots for future reference.
defineTile('w', 'ENTER_KHAZAD_DUM_HOUSE_QUEST', nil, nil, nil, nil, { type='quest', subtype='house' })

defineTile('1', 'PERMA_WALL', nil, nil, 'GENERAL_STORE')
defineTile('2', 'PERMA_WALL', nil, nil, 'ARMOURY')
defineTile('3', 'PERMA_WALL', nil, nil, 'WEAPONSMITH')
defineTile('4', 'PERMA_WALL', nil, nil, 'TEMPLE')
defineTile('5', 'PERMA_WALL', nil, nil, 'ALCHEMY_SHOP')
defineTile('7', 'PERMA_WALL', nil, nil, 'BLACK_MARKET')
defineTile('9', 'PERMA_WALL', nil, nil, 'BOOK_STORE')
defineTile('f', 'PERMA_WALL', nil, nil, 'FIGHTERS_HALL')
defineTile('g', 'PERMA_WALL', nil, nil, 'PALADINS_GUILD')
defineTile('h', 'PERMA_WALL', nil, nil, 'INNER_TEMPLE')
defineTile('i', 'PERMA_WALL', nil, nil, 'MINING_SUPPLY_STORE')

-- '@' tiles, also being undefined, will also pass through PlasmaWilderness
-- tiles; we use them for the border instead of ' ' purely for cosmetic
-- reasons, as spaces would be hard to see on the borders.
return [[
######################################################################################################################################################################################################
#ooooooooooooo####^^^^^^^^^#######^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^#####oooo#######oo######^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^##########oooooooooo     CCCCCCC             #
#ooo##ooooooooo#####^^^^^##########^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^########ooo########ooo##########^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^################oooooooooooo     CCCCCCCC           #
##oo###oo####oo##############################^^^^^^^^^^^^^^^^^########################oooo#########oo####  ###########^^^^^^^^^^^^^^^^^^^^^^^^#######    #######oooo##########     CCCCCCCC          #
##############o#########oo###oo###################^^^^^^^############################oooo#########oo######       #################################   #####ooooooooo#############     CCCCCCCC      ; #
#^^^^########oooooooooooooo##ooooooooo#############################  #################oooo########oo###########     ##########################     ######ooooooooo################     CCCCCCCC ;    #
#############ooooooooooooooooooooooooooo######  ###########1######  ##############2####oooo#######o##o##3####f#####    ##g####4####h######    ###########ooo########################     CCCCCCCC  ; #
#^#############ooooo##################oo### # #### # #####   #### ###############   ###ooo########ooo##   ##   ######  #   ##   ##   ##      # #######ooooo###########################     CCCCCCCC  #
#^^################oo#################ooooo####       ## ;                          ;;  o        ; o       ##                                   # ooooooooo############################     CCCCCCCC #
#^^^^################o##########o#####oooooooooooooooooooooo                            o          o               ;           oooooooooooooooooooooooo##ooo############################     CCCCCCC #
#^^^^^^################################# ##   ;            o             ;     ;        o          o        ;                  o                   ##o###################################     CCCCCCC#
#^^^^^^################################          ###       o           ###              o    ###   o               ###;        o         ###      ########################################     CCCCCC#
#^^^^^#################################         #####      o          #####             o   #####  o              #####        o        #####      ########################################    CCCCCC#
#^^^^^^^################################       #######;;   o         #######            o  ####### o             #######       o       #######      ####################################### ;  CCCCCC#
#^^^^^^^^################################ #    #######     o    ;    #######            o  ####### o             #######       o       #######    ########################################    CCCCCC #
#^^^^^^^###################################     #####      o      ;  ;#####             o   #####  o              #####    ;   o        #####   ;#######################################    CCCCCCC  #
#^^^^^^^^^################################       ###       o           ###              o    ###   o               ###         o         ###      # ####################################    CCCCCC ; #
#^^^^^^^^^#################################                o                            o          o                           o                  ## ##################################    CCCCCC    #
#^^^^^^^^^^################################       ;        oooooooooooo                 o          o                oooooooooooo                     5################################    CCCCCC   ; #
#^^^^^^^^^^^^^###########################                             o                 o          o                o                               #################################    CCCCCCC     #
#^^^^^^^^^^^^^^^##########################                  ###       o           ###   o          o   ;###         o         ###                  ################################    CCCCCCC     ; #
#^^^^^^^^^^^^#############################                 ##### ;    o          #####  o          o   #####        o        #####              ; ###############################;   CCCCCCC    ;    #
#^^^^^^^^^###############################            ;    #######     o         ####### o   ;      o  #######       o       #######                 ############################    CCCCCCC          #
#^#########################################          ;    #######     oooooooo  ####### o          o  #######  oooooo       ####### o          ;   ##############################;   CCCCCCC         #
#################ooo######################              ;  #####             o   #####  o          o   #####   o             #####                 ###############oo##############     CCCCC;        #
####oo##ooo#####o#######o###ooo###########                  ###   ;          o    ###   o          o    ###    o       ;      ###   ; ;;          #########oo###oooooo#####oo######     CCCCC      ; #
#ooooooooooooooooooooooooooooooo##oooooooo                               ;   o    ;     o          o           o   ;                ;;          ; oooooooooooo##oooooooo##oooooooooo     CCCCC  ;    #
#ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo     CCCCCC      #
#oooooooooooooooooo##oooooo##oooooo##ooooo                                ;             o          o                                           ;  ooooooooo#oooooooooooooooooooooooo     CCCCC       #
#^#######################oo####ooooo#######      ###                   ###              o          o               ###;                  ###      ######o####oo####oo######oo######;    CCCCC        #
#^^#######################o###########          #####                 #####             o          o              #####                 #####    ######o####################oo####     CCCCC         #
#^#######################################      #######;;   ;         #######            o          o             #######               #######     ####oo#########################     CCCCCC        #
#^^########################################    #######          ;    #######            o          o             #######               #######    ######o############oo##########     CCCCCCC        #
#^^^###############ooo###################       #####             ;  ;#####             o          o              #####    ;            #####   ;; ######oo########ooooo#######     CCCCCCCC         #
#####oo##oo#####oooooooo##############oo##       ###       ;           ###              o          o               ###                   ###      ########oooo##oooooo#######     CCCCCCCCC        ; #
#ooooooooooo###ooooooooooooooooooooooooooo                                              o          o                                              ooooooooooooooooooooooooooo     CCCCCCCC           #
#oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo     CCCCCCCC           ; #
#^ooooooooooooooooo###oooooooooo##oooooooo                                   o          o          o            o                                 ooooooo####ooooooooooooo     CCCCCCCC              #
#^^#o###ooo#####ooo#####ooooo########oo#                    ###       ;      o    ###   o          o   ;###     o             ###                  oo#########ooooo###oo#     CCCCCCCC             ; #
#^^^^^###o################oo#############                  ##### ;           o   #####  o          o   #####    o            #####              ;   ###########oo########     CCCCCCCC          ;    #
#^^^^^^^##################################           ;    #######      ooooooo  ####### o   ;      o  #######   ooooo       #######               ########################    CCCCCCCCC              #
#^^^^^^^^^^##############################            ;    #######      o ;      ####### o          o  #######       o       ####### o          ; ##########################    CCCCCCCC              #
#^^^^^^^^^^^^^^^#########################               ;  #####       o         #####  o          o   #####        o        #####              ############################    CCCCCCCC    ;        #
#^^^^^^^^^^^^^^^^^^^###################                     ###   ;    o          ###   o          o    ###         o  ;      ###   ; ;;         ############################    CCCCCCCC            #
#^^^^^^^^^^^^^^^^^^^####################                 ;             o            ;;  o        ; o                o                       ;     ############################    CCCCCCCC         ; #
#^^^^^^^^^^^^^^^^^^######################                    ooooooooooo                o          o                oooooooooooo    ;;          ;  7###########################    CCCCCCCC     ;    #
#^^^^^^^^^^^^^^^^^^^^^^#################      ;              o           ;     ;        o          o        ;                  o                   #############################    CCCCCCCC         #
#^^^^^^^^^^^^^^^^^^^^^^^^##############          ###         o         ###              o    ###   o               ###;        o         ###      #############################    CCCCCCCCCC        #
#^^^^^^^^^^^^^^^^^^^^^^^^^############          #####        o        #####             o   #####  o              #####        o        #####         ########################    CCCCCCCCCCC        #
#^^^^^^^^^^^^^^^^^^^^^^^^^^##########          #######;;   ; o       #######            o  ####### o             #######       o       #######      ###########################    CCCCCCCCCCC       #
#^^^^^^^^^^^^^^^^^^^^^^^^^^#########i          #######       o  ;    #######            o  ####### o             #######       o       #######     ############################    CCCCCCCCCCC       #
#^^^^^^^^^^^^^^^^^^^^^^^^^###########           #####        o    ;  ;#####             o   #####  o              #####    ;   o        #####   ; ##############################    CCCCCCCCCCC      #
#^^^^^^^^^^^^^^^^^^^^^^^##############           ###       ; o         ###              o    ###   o               ###         o         ###       ##############################    CCCCCCCCCCC   ; #
#^^^^^^^^^^^^^^^^^^^^^^#################                     o                          o          o                           o                  #########oo###oo#################    CCCCCCCCCC    #
#^^^^^^^^^^^^^^^^^^#############o#######oooooooooooooooooooooo            ##            o          o                           oooooooooooooooooooooooooooooooooooo##################    CCCCCCCC  ; #
#^^^^^^^^^^^^^^^^^############ooooooooooo#     ###           ##        ########      o  o    ##    o        ##                         ##         oooooo##oooooooooo###################    CCCCCCC   #
#^^^^^^^^^^^#################ooooooooooo#### ######  ###    ####   #############  ####oooo###### #ooo# ### ######   #       ### ##    ##### ####################ooo#####################    CCCCCCC  #
#^^^^^^^^^^###################oo######oo###  ###########  #######9####################oooo########oooo############w###    ########  ######  ####################oo######################    CCCCCCC  #
#^^^^^^^##########oo####oo####ooo#########  ############# ##############^^^##########ooooo########oo######################################    #########^######oooo##ooo##################    CCCCCCC #
##^^^^^#########oooooooooooooooo#################^^#######  ###########^^^^^###########ooooo######ooo#######################################     #####^^^#######ooooooooooooo#############  ; CCCCCCC#
#^^^##########ooooooooooo##ooooo######^#########^^^^##################^^^^^^^^^^^######ooo#######oooo#########^^^^^^^^^^^^^^^^^^^###########       #####^^^#######oo##oooooooo#############    CCCCCC#
##############ooooo##########oo######^^^#####^^^^^^^^###############^^^^^^^^^^^^^^#####oooo#######ooo######^^^^^^^^^^^^^^^^^^^^^^^^^^^^######      ####^^^^^###############ooo##############    CCCCC#
########ooo#####oo##################^^^^^^^^^^^^^^^^^#############^^^^^^^^^^^^^^^^^####oo########oooo#####^^^^^^^^^^^^^^^^^^^^^^^^^^^###########   #######^^^^^#############ooo#ooo########    CCCCCC#
#o##oooooooooooooooo##############^^^^^^^^^^^^^^^^^^^^^^#########^^^^^^^^^^^^^^^^^^#####oo########oo######^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^#######  # ######^^^^^^^^^^^^########oooooooooooooo    CCCCC #
#oooooooooooooooooo########^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^########oooo#######ooooo###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^##############^^^^^^^^^^^^^^^#######ooooooooooo     CCCCC  #
######################################################################################################################################################################################################]]
