-- $Id: gondolin-house.lua 3283 2018-03-11 01:31:18Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2018 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

id = 'gondolin-house'
name = 'Dragons!'
danger_level = 25	-- cf. src/tables.c line 4193
desc = function(self, who)
  if self:isEnded() then
    return [[You have slain the dragons harrassing Gondolin, and as a reward Turgon has given you the storehouse they were nesting in to use as a house.]]
  elseif self:isCompleted() then
    return [[You have slain the dragons harrassing Gondolin.  You should return to the Tower of the King and tell Turgon.]]
  else
    return [[Dragons are harrassing the people of Gondolin.  You must enter the storehouse they are nesting in and clear them out.]]
  end
end

-- cf. util.no_reenter_completed_quest()
no_reenter_msg = [[You have already cleared the dragons' nest.  You should go tell Turgon.]]

on_quest_mon_die = function(self, who, src)
  -- Only interested in kills in the quest zone.
  if game.zone.short_name ~= 'quest-gondolin-dragons' then return end
  -- If any hostiles are dead, we're not done.
  for _, e in pairs(game.level.entities) do
    if e.reactionToward and e:reactionToward(game.player) < 0 and not e.dead then
      return
    end
  end
  -- Our work here... is done.
  game.log('#YELLOW#Gondolin is safer now.#LAST#')
  game.player:setQuestStatus('gondolin-house', self.COMPLETED)
end
