-- $Id: mana.lua 3454 2018-08-01 02:16:48Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_spells' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Spell talents generated from T2's s_mana.lua

local Entity = require 'engine.Entity'

newTalentType {
  name = 'Mana spells',
  type = 'spell/mana',
  description = 'Spells from the Mana school',
}

newTalent {
  name = [[Manathrust]],
  short_name = 'MANATHRUST',
  display_entity = Entity.new { image='talents/manathrust.png' },
  type = 'spell/mana',
  mode = 'activated',
  is_spell = true,
  skill = 'MANA',
  skill_level = 1,
  mana = spell.mana_cost,
  min_mana = 1,
  max_mana = 25,
  base_fail = 10,
  stat = 'INT',
  random_book = 'MAGIC',
  stick = {
    type = 'utility/wand',
    charge = { 7, 10 },
    rarity = 5,
    base_level = { 1, 20 },
    max_level = { 15, 33 },
  },
  requires_target = true,
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local ret = spell.bolt_spell(self, t, DamageType.MANA, rng.dice(t.dmg_dice(self, t)))
    if ret then spell.stick.id = true end
    return ret
  end,
  info = function(self, t)
    local dd, ds = t.dmg_dice(self, t)
    local mf = util.colorize_damtype(DamageType.MANA)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Conjures up mana into a powerful bolt doing %dd%d %s damage.  Damage will increase%s]]
    return ret:format(dd, ds, mf, sfx)
  end,
  -- BEGIN VERBATIM
  dmg_dice = function(self, t)
    local l50 = spell.get_spell_level(self, t)
    local l20 = spell.get_spell_level(self, t, 20)
    return 3 + l50, 1 + l20
  end,
  -- END VERBATIM
}

newTalent {
  name = [[Remove Curses]],
  short_name = 'REMOVE_CURSE',
  display_entity = Entity.new { image='talents/remove_curses.png' },
  type = 'spell/mana',
  mode = 'activated',
  is_spell = true,
  skill = 'MANA',
  skill_level = 10,
  mana = spell.mana_cost,
  min_mana = 20,
  max_mana = 40,
  base_fail = 30,
  stat = 'INT',
  random_book = 'MAGIC',
  inertia = { 1, 10 },
  stick = {
    type = 'utility/staff',
    charge = { 3, 8 },
    rarity = 70,
    base_level = { 1, 5 },
    max_level = { 15, 50 },
  },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t)
    local any = spell.uncurse_inven(self, lev >= 20)
    if any then
      game.logPlayer(self, 'The curse is broken!')
      spell.stick.id = true
    end
    return true
  end,
  info = function(self, t)
    return [[Removes curses from all worn items and everything in your inventory.  Starting at level 20, also removes heavy curses.]]
  end,
}

newTalent {
  name = [[Elemental Shield]],
  short_name = 'ELEM_SHIELD',
  display_entity = Entity.new { image='talents/elemental_shield.png' },
  type = 'spell/mana',
  mode = 'activated',
  is_spell = true,
  skill = 'MANA',
  skill_level = 20,
  mana = spell.mana_cost,
  min_mana = 17,
  max_mana = 20,
  base_fail = 40,
  stat = 'INT',
  random_book = 'MAGIC',
  inertia = { 2, 25 },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local base = 15 + spell.get_spell_level(self, t)
    local p = { merge='no_replace' }
    self:setEffect(self.EFF_RES_FIRE, base + rng.range(1, 10), p)
    self:setEffect(self.EFF_RES_COLD, base + rng.range(1, 10), p)
    self:setEffect(self.EFF_RES_LIGHTNING, base + rng.range(1, 10), p)
    self:setEffect(self.EFF_RES_ACID, base + rng.range(1, 10), p)
  end,
  info = function(self, t)
    local base = 15 + spell.get_spell_level(self, t)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Provides temporary resistance to fire, cold, lightning and acid (duration %d+1d10, computed separately for each effect).  Duration will increase%s

#{bold}#NOTE:#{normal}#  If you already have temporary resistance effects for any of those damage types, the spell will not replace or increase the durations of those effects.]]
    return ret:format(base, sfx)
  end,
}

newTalent {
  name = [[Disruption Shield]],
  short_name = 'DISRUPT_SHIELD',
  display_entity = Entity.new { image='talents/disruption_shield.png' },
  type = 'spell/mana',
  mode = 'activated',
  is_spell = true,
  skill = 'MANA',
  skill_level = 45,
  mana = spell.mana_cost,
  min_mana = 50,
  max_mana = 50,
  base_fail = 90,
  stat = 'INT',
  random_book = 'MAGIC',
  inertia = { 9, 10 },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t)
    local eff_id = lev >= 5 and self.EFF_INVULNERABILTIY or self.EFF_DISRUPTION_SHIELD
    local base_dur = 3 + spell.get_spell_level(self, t, 10)
    local p = { merge='no_replace' }
    self:setEffect(eff_id, base_dur + rng.range(1, 5), p)
  end,
  info = function(self, t)
    local base_dur = 3 + spell.get_spell_level(self, t, 10)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Surrounds you with a mana shield for %d+1d5 turns.  While the shield is active, all incoming damage will be applied to your Mana rather than hit points.  At level 5, the shield becomes a Globe of Invulnerability, increasing your AC by 100.  Duration will increase%s

#{bold}#NOTE:#{normal}#  Either shield will break if you attempt to cast any spell, use any talent, attack in melee, or throw or shoot anything.  If the shield is currently active, re-casting the spell will not increase its duration.]]
    return ret:format(base_dur, sfx)
  end,
}
