-- $Id: timed_effects_zone_gen.lua 3850 2020-04-05 20:13:34Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2020 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_zones' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Zone-wide damage effects from T2's d_info.txt

newEffect {
  name = 'ZONE_MOUNT_DOOM',
  desc = [[Zone: Mount Doom]],
  display = function(eff) return 'Zone:MDm' end,
  type = 'other',
  status = 'detrimental',
  cancel_on_level_change = true, -- Will be re-added by changeLevel() as needed
  decrease = 0, -- Lasts until we leave the zone
  no_dur = true, -- Don't show duration in the status display.
  zone_effect = true,
  ambient = {
    frequency = 10,
    damage = { 2, 10 },
    damtype = DamageType.FIRE,
    src_name = [[the fires of Mount Doom]],
    src_plural = true,
    kill_text = [[the fires of Mount Doom]],
  },
  on_timeout = util.effect_repeat_damage,
  describe = function(who, p)
    local damf = util.colorize_dam(DamageType.FIRE)
    local fmt = [[All around you the fires of Mount Doom are burning, making the air almost scalding hot.  While you are in this zone, you will take 2d10 %s damage every 10 turns.]]
    return tstring { fmt:format(damf) }
  end,
  -- BEGIN VERBATIM
  -- Sneaky Hack(TM):  The gen_zones script scrapes these VERBATIM blocks
  -- to get the lead sentence for the various effects' describe() methods.
  -- We specify it as a comment because we don't need it at runtime outside
  -- of the above.
  -- "All around you the fires of Mount Doom are burning, making the air almost scalding hot."
  -- @"the fires of Mount Doom" src_plural
  -- END VERBATIM
}

newEffect {
  name = 'ZONE_NETHER_REALM',
  desc = [[Zone: Nether Realm]],
  display = function(eff) return 'Zone:Nth' end,
  type = 'other',
  status = 'detrimental',
  cancel_on_level_change = true, -- Will be re-added by changeLevel() as needed
  decrease = 0, -- Lasts until we leave the zone
  no_dur = true, -- Don't show duration in the status display.
  zone_effect = true,
  ambient = {
    frequency = 3,
    damage = { 10, 10 },
    damtype = DamageType.NETHER,
    src_name = [[the nether mists of the Nether Realm]],
    src_plural = true,
    kill_text = [[choking nether]],
  },
  on_timeout = util.effect_repeat_damage,
  describe = function(who, p)
    local damf = util.colorize_dam(DamageType.NETHER)
    local fmt = [[Instead of air, this realm is filled with choking nether vapors.  While you are in this zone, you will take 10d10 %s damage every 3 turns.]]
    return tstring { fmt:format(damf) }
  end,
  -- BEGIN VERBATIM
  -- "Instead of air, this realm is filled with choking nether vapors."
  -- @"the nether mists of the Nether Realm" src_plural
  -- END VERBATIM
}

newEffect {
  name = 'ZONE_SUBMERGED_RUINS',
  desc = [[Zone: Submerged Ruins]],
  display = function(eff) return 'Zone:Num' end,
  type = 'other',
  status = 'detrimental',
  cancel_on_level_change = true, -- Will be re-added by changeLevel() as needed
  decrease = 0, -- Lasts until we leave the zone
  no_dur = true, -- Don't show duration in the status display.
  zone_effect = true,
  ambient = {
    frequency = 1,
    damage = { 1, 1 },
    damtype = DamageType.ACID,
    src_name = [[the acidic waters around Númenor]],
    src_plural = true,
    kill_text = [[acidic waters]],
  },
  on_timeout = util.effect_repeat_damage,
  describe = function(who, p)
    local damf = util.colorize_dam(DamageType.ACID)
    local fmt = [[The water is slightly acidic here.  While you are in this zone, you will take 1 %s damage every turn.]]
    return tstring { fmt:format(damf) }
  end,
  -- BEGIN VERBATIM
  -- "The water is slightly acidic here."
  -- @"the acidic waters around Númenor" src_plural
  -- END VERBATIM
}

newEffect {
  name = 'ZONE_CIRITH_UNGOL',
  desc = [[Zone: Cirith Ungol]],
  display = function(eff) return 'Zone:CUg' end,
  type = 'other',
  status = 'detrimental',
  cancel_on_level_change = true, -- Will be re-added by changeLevel() as needed
  decrease = 0, -- Lasts until we leave the zone
  no_dur = true, -- Don't show duration in the status display.
  zone_effect = true,
  ambient = {
    frequency = 20,
    damage = { 4, 4 },
    damtype = DamageType.POISON,
    src_name = [[the toxic vapors of Cirith Ungol]],
    src_plural = true,
    kill_text = [[the toxic vapors of Cirith Ungol]],
  },
  on_timeout = util.effect_repeat_damage,
  describe = function(who, p)
    local damf = util.colorize_dam(DamageType.POISON)
    local fmt = [[You can smell the venomous auras of Shelob's teeming spawn in the air.  While you are in this zone, you will take 4d4 %s damage every 20 turns.]]
    return tstring { fmt:format(damf) }
  end,
  -- BEGIN VERBATIM
  -- "You can smell the venomous auras of Shelob's teeming spawn in the air."
  -- @"the toxic vapors of Cirith Ungol" src_plural
  -- END VERBATIM
}

newEffect {
  name = 'ZONE_THE_VOID',
  desc = [[Zone: The Void]],
  display = function(eff) return 'Zone:Vod' end,
  type = 'other',
  status = 'detrimental',
  cancel_on_level_change = true, -- Will be re-added by changeLevel() as needed
  decrease = 0, -- Lasts until we leave the zone
  no_dur = true, -- Don't show duration in the status display.
  zone_effect = true,
  ambient = {
    frequency = 100,
    damage = { 20, 6 },
    damtype = DamageType.DARK,
    src_name = [[the darkness of the Void]],
    kill_text = [[the empty darkness of the Void]],
  },
  on_timeout = util.effect_repeat_damage,
  describe = function(who, p)
    local damf = util.colorize_dam(DamageType.DARK)
    local fmt = [[The darkness, ironically, seems to exert an almost physical pressure on you here in the empty Void.  While you are in this zone, you will take 20d6 %s damage every 100 turns.]]
    return tstring { fmt:format(damf) }
  end,
  -- BEGIN VERBATIM
  -- "The darkness, ironically, seems to exert an almost physical pressure on you here in the empty Void."
  -- @"the darkness of the Void"
  -- END VERBATIM
}

newEffect {
  name = 'ZONE_PATHS_OF_THE_DEAD',
  desc = [[Zone: Paths of the Dead]],
  display = function(eff) return 'Zone:PoD' end,
  type = 'other',
  status = 'detrimental',
  cancel_on_level_change = true, -- Will be re-added by changeLevel() as needed
  decrease = 0, -- Lasts until we leave the zone
  no_dur = true, -- Don't show duration in the status display.
  zone_effect = true,
  ambient = {
    frequency = 20,
    damage = { 1, 1 },
    damtype = DamageType.RAISE,
    src_name = [[a mysterious force]],
    kill_text = [[being raised from the dead (?)]],
  },
  on_timeout = util.effect_repeat_damage,
  describe = function(who, p)
    local damf = util.colorize_dam(DamageType.RAISE)
    local fmt = [[The dead do not rest easy here.  While you are in this zone, you will take 1 %s damage every 20 turns.]]
    return tstring { fmt:format(damf) }
  end,
  -- BEGIN VERBATIM
  -- "The dead do not rest easy here."
  -- @"a mysterious force"
  -- END VERBATIM
}

newEffect {
  name = 'ZONE_ILLUSORY_CASTLE',
  desc = [[Zone: Illusory Castle]],
  display = function(eff) return 'Zone:Ill' end,
  type = 'other',
  status = 'detrimental',
  cancel_on_level_change = true, -- Will be re-added by changeLevel() as needed
  decrease = 0, -- Lasts until we leave the zone
  no_dur = true, -- Don't show duration in the status display.
  zone_effect = true,
  ambient = {
    frequency = 6,
    damage = { 6, 2 },
    damtype = DamageType.CONFUSION,
    src_name = [[a confusing effect]],
    kill_text = [[terminal perplexity]],
  },
  on_timeout = util.effect_repeat_damage,
  describe = function(who, p)
    local damf = util.colorize_dam(DamageType.CONFUSION)
    local fmt = [[You can sense a magical effect tingling at the edge of your mind, making it hard to keep track of where you're going.  While you are in this zone, you will take 6d2 %s damage every 6 turns.]]
    return tstring { fmt:format(damf) }
  end,
  -- BEGIN VERBATIM
  -- "You can sense a magical effect tingling at the edge of your mind, making it hard to keep track of where you're going."
  -- @"a confusing effect"
  -- END VERBATIM
}

newEffect {
  name = 'ZONE_THE_SMALL_WATER_CAVE',
  desc = [[Zone: The Small Water Cave]],
  display = function(eff) return 'Zone:SWC' end,
  type = 'other',
  status = 'detrimental',
  cancel_on_level_change = true, -- Will be re-added by changeLevel() as needed
  decrease = 0, -- Lasts until we leave the zone
  no_dur = true, -- Don't show duration in the status display.
  zone_effect = true,
  ambient = {
    frequency = 20,
    damage = { 1, 1 },
    damtype = DamageType.ACID,
    src_name = [[the acidic water in the cave]],
    kill_text = [[acidic waters]],
  },
  on_timeout = util.effect_repeat_damage,
  describe = function(who, p)
    local damf = util.colorize_dam(DamageType.ACID)
    local fmt = [[The water is slightly acidic here.  While you are in this zone, you will take 1 %s damage every 20 turns.]]
    return tstring { fmt:format(damf) }
  end,
  -- BEGIN VERBATIM
  -- "The water is slightly acidic here."
  -- @"the acidic water in the cave"
  -- END VERBATIM
}

newEffect {
  name = 'ZONE_THE_HELCARAXE',
  desc = [[Zone: The Helcaraxë]],
  display = function(eff) return 'Zone:Ice' end,
  type = 'other',
  status = 'detrimental',
  cancel_on_level_change = true, -- Will be re-added by changeLevel() as needed
  decrease = 0, -- Lasts until we leave the zone
  no_dur = true, -- Don't show duration in the status display.
  zone_effect = true,
  ambient = {
    frequency = 15,
    damage = { 1, 4 },
    damtype = DamageType.COLD,
    src_name = [[the bitter winds of the Helcaraxë]],
    src_plural = true,
    kill_text = [[terminal exposure to cold]],
  },
  on_timeout = util.effect_repeat_damage,
  describe = function(who, p)
    local damf = util.colorize_dam(DamageType.COLD)
    local fmt = [[It is bitterly cold here.  While you are in this zone, you will take 1d4 %s damage every 15 turns.]]
    return tstring { fmt:format(damf) }
  end,
  -- BEGIN VERBATIM
  -- "It is bitterly cold here."
  -- @"the bitter winds of the Helcaraxë" src_plural
  -- END VERBATIM
}
