-- $Id: zone.lua 3850 2020-04-05 20:13:34Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2020 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

-- Zone file for Orc Cave.

return {
  name = 'Orc Cave',
  display_abbr = 'Orc',
  level_scheme = 'fixed',
  max_level = 13,
  level_range = { 10, 22 },
  width = 198,
  height = 66,

  generator = {
    map = {
      class = 'mod.class.generator.map.T2DungeonLevel',
      floor = { 'DIRT' },
      fill = { 'MOUNTAIN_CHAIN' },
      outer_wall = 'WALL',
      inner_wall = 'MOUNTAIN_CHAIN',
      fill_step = 0,
      up = 'UP',
      down = 'DOWN',
      flags = {
	RANDOM_TOWNS = true,
	CAVE = true,
      },
    },
    actor = {
      class = 'mod.class.generator.actor.T2LevelFilteredActors',
      init_npc = 35,
      respawn_in = 200,
      filters = {
	{ prob=30, mode='or', flags={ 'TROLL' } },
	{ prob=20, mode='any' },
	{ prob=50, mode='or', syms={ 'k', 'o', 'O' }, flags={ 'ORC' } },
      },
      guardian = 'AZOG_KING_OF_THE_URUK_HAI',
    },
    object = {
      class = 'mod.class.generator.object.T2LevelFilteredObjects',
      weights = { treasure=5, combat=50, magic=10, tools=25, junk=10 },
    },
    trap = {
      class = 'mod.class.generator.trap.T2LevelFilteredTraps',
    },
  },
  alter_level_data = util.adjust_level,
  levels = {
    [1] = {
      generator = {
	map = {
	  up = 'UP_TO_WILDERNESS',
	  -- up_lev = 1
	},
      },
    },
    [12] = {
      no_level_connectivity = true,
      level_name = [[Deathwatch]],
      enter_desc = [[This level looks filled with evilness.]],
      generator = {
	map = {
	  class='mod.class.generator.map.Static',
	  map = 'zones/deathwatch',
	  one_time_level = 'deathwatch',
	  flags = { DESC=true, NO_GENO=true, NO_NEW_MONSTER=true, SPECIAL=true, NO_STAIR=true, ASK_LEAVE=true, NO_TELEPORT=true },
	},
	actor = {
	  init_npc = table.NIL_MERGE,
	  respawn_in = table.NIL_MERGE,
	},
      },
    },
  },
}
