-- $Id: traps.lua 3333 2018-04-20 00:32:38Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2018 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

load('/data/general/traps/store.lua')

newEntity {
  base = 'BASE_STORE',
  define_as = 'GONDOLIN_HOME',
  name = "Your home (née Dragons' Nest)",
  resolvers.store('GONDOLIN_HOME', 'home'),
}

newEntity {
  base = 'BASE_STORE',
  define_as = 'TOWER_OF_THE_KING',
  name = "Tower of the King",
  resolvers.building_chat('turgon', 'TOWER_OF_THE_KING'),
}

newEntity {
  base = 'BASE_STORE',
  define_as = 'GONDOLIN_LIBRARY',
  name = "Library",
  resolvers.store('GONDOLIN_LIBRARY'),
  resolvers.building_chat('gondolin-library'),
}

newEntity {
  base = 'BASE_STORE',
  define_as = 'THE_WHITE_TREE',
  name = "The White Tree",
  resolvers.store('THE_WHITE_TREE'),
  resolvers.building_chat('inn'),
}

newEntity {
  base = 'BASE_STORE',
  define_as = 'CRAFTSMASTER',
  name = "Craftsmaster",
  owner = resolvers.store_owner('CRAFTSMASTER'),
  resolvers.building_chat('gondolin-craftsmaster', 'CRAFTSMASTER'),
}

newEntity {
  base = 'BASE_STORE',
  define_as = 'EARTH_DOME_NATURE_',
  name = "Earth-Dome (Nature)",
  owner = resolvers.store_owner('EARTH_DOME_NATURE_'),
  resolvers.building_chat('gondolin-earth-dome', 'EARTH_DOME_NATURE_'),
}

newEntity {
  base = 'BASE_STORE',
  define_as = 'THE_SOOTHSAYER',
  name = "The Soothsayer",
  resolvers.store('THE_SOOTHSAYER'),
  resolvers.building_chat('soothsayer'),
}

newEntity {
  base = 'BASE_STORE',
  define_as = 'MINSTRELS_HAVEN',
  name = "Minstrels Haven",
  owner = resolvers.store_owner('MINSTRELS_HAVEN'),
  resolvers.building_chat('gondolin-minstrels-haven', 'MINSTRELS_HAVEN'),
}

newEntity {
  base = 'BASE_STORE',
  define_as = 'STAR_DOME',
  name = "Star-Dome",
  owner = resolvers.store_owner('STAR_DOME'),
  resolvers.building_chat('gondolin-star-dome', 'STAR_DOME'),
}

newEntity {
  base = 'BASE_STORE',
  define_as = 'VALARIN_TEMPLE',
  name = "Valarin Temple",
  owner = resolvers.store_owner('VALARIN_TEMPLE'),
  resolvers.building_chat('gondolin-valarin-temple', 'VALARIN_TEMPLE'),
}

newEntity {
  base = 'BASE_STORE',
  define_as = 'SEA_DOME',
  name = "Sea-Dome",
  resolvers.building_chat('placeholder', 'SEA_DOME'),
}

newEntity {
  base = 'BASE_STORE',
  define_as = 'THE_GOLDEN_FLOWER',
  name = "The Golden Flower",
  owner = resolvers.store_owner('THE_GOLDEN_FLOWER'),
  resolvers.building_chat('gondolin-golden-flower', 'THE_GOLDEN_FLOWER'),
}

newEntity {
  base = 'BASE_STORE',
  define_as = 'THE_FOUNTAIN',
  name = "The Fountain",
  owner = resolvers.store_owner('THE_FOUNTAIN'),
  resolvers.building_chat('gondolin-fountain', 'THE_FOUNTAIN'),
}

newEntity {
  base = 'BASE_STORE',
  define_as = 'THUNDERLORDS_NEST',
  name = "Thunderlords' Nest",
  owner = resolvers.store_owner('THUNDERLORDS_NEST'),
  resolvers.building_chat('thunderlords-nest', 'THUNDERLORDS_NEST'),
}

newEntity {
  base = 'BASE_STORE',
  define_as = 'MERCHANTS_GUILD',
  name = "Merchants Guild",
  resolvers.building_chat('placeholder', 'MERCHANTS_GUILD'),
}

newEntity {
  base = 'BASE_STORE',
  define_as = 'RARE_JEWELRY_SHOP',
  name = "Royal Jewelry Shop",
  resolvers.store('RARE_JEWELRY_SHOP'),
}
