-- $Id: World.lua 3557 2019-01-17 03:35:53Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2019 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

require "engine.class"
require "engine.World"
require "engine.interface.WorldAchievements"

module(..., package.seeall, class.inherit(engine.World,
					  engine.interface.WorldAchievements))

function _M:init()
  engine.World.init(self)
end

function _M:run()
  self:loadAchievements()
end

--- Requests the world to save
function _M:saveWorld(no_dialog)
  -- savefile_pipe is created as a global by the engine
  savefile_pipe:push("", "world", self)
end

-- Format an achievement source
function _M:achievementWho(src)
  local race = src.descriptor.race
  local subrace = src.descriptor.subrace
  local class = src.descriptor.class
  if subrace ~= 'Base' then
    local Birther = require "engine.Birther"
    local srd = Birther:getBirthDescriptor('subrace', subrace)
    race = srd.name_mod == 'suffix' and race..' '..subrace or subrace..' '..race
  end
  return ('%s the level %d %s %s'):format(src.name, src.level, race, class)
end
